Attribute VB_Name = "modSystem"
Option Explicit

Public CancelApp As Boolean
Public EndApp As Boolean

Public FragmentSize As Double
Public InputFile As String
Public OutputFolder As String

Private Buffer(0 To 524287) As Byte

Public Sub SplitFullPath(ByVal CompletePath As String, ByRef FilePath As String, ByRef FileName As String, ByRef FileExt As String)
On Error Resume Next
Dim pos As Long
Dim pos2 As Long
Dim s As String
s = CompletePath
pos = 0
pos2 = InStr(1, s, "\")
While pos2 > 0
 pos = pos2: pos2 = InStr(pos2 + 1, s, "\")
Wend
If pos = 0 Then
  FilePath = ""
Else
  FilePath = Left(s, pos)
  s = Mid(s, pos + 1)
End If

pos = 0
pos2 = InStr(1, s, ".")
While pos2 > 0
 pos = pos2: pos2 = InStr(pos2 + 1, s, ".")
Wend

If pos = 0 Then
  FileName = s
  FileExt = ""
Else
  FileName = Left(s, pos - 1)
  FileExt = Mid(s, pos + 1)
End If
  

End Sub

Sub DeleteFragmentFiles(eMask As String, sFileName As String)

Dim fFile As String
Dim fNum As Integer
Do
    fNum = fNum + 1
    fFile = sFileName & "." & CStr(Format(fNum, eMask))
    If Dir(fFile) = "" Then Exit Do
    Kill fFile
Loop

End Sub

Public Sub MergeFiles()
On Error Resume Next
Dim i As Long
Dim j As Long

Dim FPath As String
Dim FName As String
Dim FExt As String
Dim FNameNoExt As String

' Variables used to hold values returned by the ReadFile and WriteFile API functions
Dim bRead As Long
Dim bWrote As Long

' File handles used to read and write to files
Dim fIn As Long     ' input file handle
Dim fOut As Long    ' output file handle

' Temporary variables
Dim TempCurr As Currency
Dim TempDbl As Double
Dim TempLng As Long

Dim TotalBytes As Double
Dim RemainingBytes As Double
Dim BytesDone As Double
Dim DestinationFile As String
Dim FragmentFile As String
Dim FragmentNumber As Integer
Dim Fragments As Integer
Dim FromFile As String

Dim dFileNoMask As String

Dim Progress As Double
Dim Speed As Double
Dim OldTime As Double
Dim NewTime As Double
Dim OldBytes As Double
Dim NewBytes As Double
Dim Count As Long
Dim extMask As String


'Make sure the source file name is given and is valid (exists)
If InputFile = "" Then
 MsgBox "Please specify an input file first.", vbOKOnly Or vbExclamation, "Error": Exit Sub
End If

fIn = CreateFile(InputFile, GENERIC_READ, FILE_SHARE_READ Or FILE_SHARE_WRITE, 0&, OPEN_EXISTING, 0, 0)
If fIn = INVALID_HANDLE_VALUE Then
   MsgBox "Can not open input file. Process aborted.", vbOKOnly Or vbExclamation, "Error": Exit Sub
End If
CloseHandle fIn
   
SplitFullPath InputFile, FPath, FNameNoExt, FExt
FName = FNameNoExt & "." & FExt
    
' Getting extension mask format
extMask = String$(InStr(1, StrReverse(InputFile), ".") - 1, vbKey0)

' Find the number of Fragments of the split file that resides in
'the same directory where the source file is
' Also count the total number of bytes in the Fragments (this will be
'used for the calculation of the percent done value

dFileNoMask = FPath & FNameNoExt
Fragments = 0
BytesDone = 0
OldTime = GetTickCount()
OldBytes = 0

Do
  'Increase the number of Fragments counter by 1
  Fragments = Fragments + 1
  'Compose the Fragment file name and check
  FragmentFile = FPath & FNameNoExt & "." & CStr(Format(Fragments, extMask))
  fIn = CreateFile(FragmentFile, GENERIC_READ, FILE_SHARE_READ Or FILE_SHARE_WRITE, 0&, OPEN_EXISTING, 0, 0)
  If fIn = INVALID_HANDLE_VALUE Then
   'MsgBox "Can not open input file. Process aborted.", vbOKOnly Or vbCritical, "Error"
   'ResetInterface
   Exit Do  ' file not found or it can not be opened
  Else
   GetFileSizeEx fIn, TempCurr
   TotalBytes = TotalBytes + TempCurr * 10000
  End If
  CloseHandle fIn
Loop
    
Fragments = Fragments - 1 'This is the number of Fragments found
'Check the detected number of Fragments.
'If is =0, then the given file name is not a Fragment file
If Fragments = 0 Then
 MsgBox "There was a problem detecting the numbers of fragments. Process aborted.", vbOKOnly Or vbExclamation, "Error"
 ResetInterface
 Exit Sub
End If
'Check if the destination file to be created does exist in the same dir
'If yes, return error in the function return value
DestinationFile = OutputFolder & FNameNoExt
CloseHandle fIn
fIn = CreateFile(DestinationFile, GENERIC_READ, FILE_SHARE_READ Or FILE_SHARE_WRITE, 0&, OPEN_EXISTING, 0, 0)

If fIn <> INVALID_HANDLE_VALUE Then
 Dim ret As Long
 ret = MsgBox("A file named " & FNameNoExt & " already exists in the output folder." & vbCrLf & _
              "Do you wish to overwrite it?", vbYesNo Or vbQuestion, "Overwrite destionation file")
 If ret <> vbYes Then
  CloseHandle fIn
  ResetInterface
  Exit Sub
  
 End If
End If

'Open the destination file in write mode
fOut = CreateFile(DestinationFile, GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, 0&, CREATE_ALWAYS, 0, 0)
If fOut = INVALID_HANDLE_VALUE Then
  MsgBox "Can not create the destination file. Process aborted.", vbOKOnly Or vbCritical, "Error"
  ResetInterface
  Exit Sub
End If

Do

  'Increase the number of Fragments counter by 1
  FragmentNumber = FragmentNumber + 1
  'Compose the file name of the new Fragment file to be opened and read
  FromFile = FPath & FNameNoExt & "." & CStr(Format(FragmentNumber, extMask))
  'Open the source file Fragment in read mode
  fIn = CreateFile(FromFile, GENERIC_READ, FILE_SHARE_READ Or FILE_SHARE_WRITE, 0&, OPEN_EXISTING, 0, 0)
  'Get the total number of bytes in the current Fragment file
  GetFileSizeEx fIn, TempCurr
  RemainingBytes = TempCurr * 10000
  ' Read bytes from the source file (the current Fragment file) and write them
  'to the destination file. Depending on the remaining bytes to read and write,
  'the routine below will read the largest possible chunk of data
  Do
    'Clean up after canceling
  If CancelApp Or EndApp Then
   CloseHandle fOut
   CloseHandle fIn
   Kill DestinationFile
   PBarSetPos 1, 0
   If EndApp Then
    PBarUnload 1
    End
   Else
    MsgBox "Cancelled.", vbOKOnly Or vbInformation, "File Merger"
   End If
   ResetInterface
   Exit Sub
  End If
   Select Case RemainingBytes
    Case Is > 524288
      ReadFile fIn, Buffer(0), 524288, bRead, ByVal 0&
      WriteFile fOut, Buffer(0), 524288, bWrote, ByVal 0&
      RemainingBytes = RemainingBytes - 524288
      BytesDone = BytesDone + 524288
      
    Case 32768 To 524288
      TempLng = (RemainingBytes \ 4096) * 4096
      ReadFile fIn, Buffer(0), TempLng, bRead, ByVal 0&
      WriteFile fOut, Buffer(0), TempLng, bWrote, ByVal 0&
      RemainingBytes = RemainingBytes - TempLng
      BytesDone = BytesDone + TempLng
      
    Case 1 To 32768
      ReadFile fIn, Buffer(0), RemainingBytes, bRead, ByVal 0&
      WriteFile fOut, Buffer(0), RemainingBytes, bWrote, ByVal 0&
      BytesDone = BytesDone + RemainingBytes
      RemainingBytes = 0
      
    Case Is = 0
      'When the loop enters here, the Fragment bytes are completed.
      'Close the Fragment file and exit the loop
      CloseHandle fIn
      
      Exit Do
   End Select
   'Update the percent control on the form
   
 NewTime = GetTickCount()
 If NewTime = OldTime Then NewTime = OldTime + 1 ' prevent division by 0 if speed is too fast
 NewBytes = BytesDone
 Progress = (BytesDone / TotalBytes) * 100
 If Progress > 100 Then Progress = 100
 Count = Count + 1
 If Count > 5 Then
  Speed = (NewBytes - OldBytes) / (NewTime - OldTime)
  Speed = Speed * 0.9765  '(1000ms / 1024 KB)
 
  OldBytes = NewBytes
  OldTime = NewTime
  Count = 0
 End If
 frmMain.lblProgressText.Caption = "Working: " & CStr(Round(BytesDone / 1024, 0)) & "KB read so far at " & CStr(Round(Speed, 2)) & "KB/s (" & CStr(Round(Progress, 2)) & "%)"
 PBarSetPos 1, Int(Progress)
 NewDoEvents
 Loop
Loop Until FragmentNumber = Fragments
'Close the destination file
CloseHandle fOut
CloseHandle fIn

PBarSetPos 1, 0
ResetInterface
MsgBox "Done.", vbOKOnly Or vbInformation, "File Merger"
End Sub

Private Sub ResetInterface()
frmMain.cmdStart.Caption = "Start"
frmMain.lblProgressText.Caption = "Ready."
CancelApp = False
EndApp = False
PBarSetPos 1, 0
End Sub
